Reference Manual

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# Inti::Gtk::ProgressBar Class Reference

A GtkProgressBar C++ wrapper class. More...

`#include <inti/gtk/progressbar.h>`

Inheritance diagram for Inti::Gtk::ProgressBar:

List of all members.

## Public Member Functions

Constructors

- ProgressBar ()
    Construct a new progress bar.
- ProgressBar (ProgressBarOrientation orientation)
    Construct a new progress bar with the specified orientation.

Accessors

- GtkProgressBar * gtk_progress_bar () const
    Get a pointer to the GtkProgressBar structure.
- GtkProgressBarClass * gtk_progress_bar_class () const
    Get a pointer to the GtkProgressBarClass structure.
- operator GtkProgressBar * () const
    Conversion operator; safely converts a ProgressBar to a GtkProgressBar pointer.
- double get_fraction () const
    Returns the current fraction of the task that's been completed.
- double get_pulse_step () const
    Retrieves the pulse step set with set_pulse_step().
- ProgressBarOrientation get_orientation () const
    Retrieves the current progress bar orientation.

Methods

- void pulse ()
    Indicates that some progress is made, but you don't know how much.
- void set_text (const String &text)
    Causes the given text to appear superimposed on the progress bar.
- void set_fraction (double fraction)
    Causes the progress bar to "fill in" the given fraction of the bar.
- void set_pulse_step (double fraction)
    Sets the fraction of total progress bar length to move the bouncing block for each call to pulse().
- void set_orientation (ProgressBarOrientation orientation)
    Causes the progress bar to switch to a different orientation (left-to-right, right-to-left, top-to-bottom, or bottom-to-top).

Property Proxies

- const OrientationPropertyProxy prop_orientation ()
    Orientation and growth direction of the progress bar (ProgressBarOrientation : Read / Write).
- const FractionPropertyProxy prop_fraction ()
    The fraction of total work that has been completed (double : Read / Write).
- const PulseStepPropertyProxy prop_pulse_step ()
    The fraction of total progress to move the bouncing block when pulsed (double : Read / Write).
- const TextPropertyProxy prop_text ()
    The text to be displayed in the progress bar (String : Read / Write).

## Protected Member Functions

Constructors

- ProgressBar (GtkProgressBar *progress_bar, bool reference=false)
    Construct a new ProgressBar from an existing GtkProgressBar.

## Detailed Description

A GtkProgressBar C++ wrapper class.

The ProgressBar is typically used to display the progress of a long running operation. It provides a visual clue that processing is underway. The ProgressBar can be used in two different modes: percentage mode and activity mode.

When an application can determine how much work needs to take place (e.g. read a fixed number of bytes from a file) and can monitor its progress, it can use the ProgressBar in percentage mode and the user sees a growing bar indicating the percentage of the work that has been completed. In this mode, the application is required to call set_fraction() periodically to update the progress bar.

When an application has no accurate way of knowing the amount of work to do, it can use the ProgressBar in activity mode, which shows activity by a block moving back and forth within the progress area. In this mode, the application is required to call pulse() perodically to update the progress bar.

There is quite a bit of flexibility provided to control the appearance of the ProgressBar. Functions are provided to control the orientation of the bar, optional text can be displayed along with the bar, and the step size used in activity mode can be set.

## Constructor & Destructor Documentation

Inti::Gtk::ProgressBar::ProgressBar | ( | GtkProgressBar * | progress_bar,
|  | bool | reference = false
| ) | `[explicit, protected]`

  | Construct a new ProgressBar from an existing GtkProgressBar. Parameters:
  progress_bar | A pointer to a GtkProgressBar.
  reference | Set false if the initial reference count is floating, set true if it's not.
The progress_bar can be a newly created GtkProgressBar or an existing GtkProgressBar (see G::Object::Object).

Inti::Gtk::ProgressBar::ProgressBar | ( | ProgressBarOrientation | orientation | ) | `[explicit]`

  | Construct a new progress bar with the specified orientation. Parameters:
  orientation | The orientation of the progress bar.

## Member Function Documentation

double Inti::Gtk::ProgressBar::get_fraction | ( |  | ) | const

| Returns the current fraction of the task that's been completed. Returns: A fraction from 0.0 to 1.0.

double Inti::Gtk::ProgressBar::get_pulse_step | ( |  | ) | const

| Retrieves the pulse step set with set_pulse_step(). Returns: A fraction from 0.0 to 1.0.

void Inti::Gtk::ProgressBar::pulse | ( |  | ) |

| Indicates that some progress is made, but you don't know how much. Causes the progress bar to enter "activity mode", where a block bounces back and forth. Each call to pulse() causes the block to move by a little bit (the amount of movement per pulse is determined by set_pulse_step()).

void Inti::Gtk::ProgressBar::set_fraction | ( | double | fraction | ) |

  | Causes the progress bar to "fill in" the given fraction of the bar. Parameters:
  fraction | The fraction of the task that's been completed.
The fraction should be between 0.0 and 1.0, inclusive.

void Inti::Gtk::ProgressBar::set_orientation | ( | ProgressBarOrientation | orientation | ) |

  | Causes the progress bar to switch to a different orientation (left-to-right, right-to-left, top-to-bottom, or bottom-to-top). Parameters:
  orientation | The orientation of the progress bar.

void Inti::Gtk::ProgressBar::set_pulse_step | ( | double | fraction | ) |

  | Sets the fraction of total progress bar length to move the bouncing block for each call to pulse(). Parameters:
  fraction | The fraction between 0.0 and 1.0.

void Inti::Gtk::ProgressBar::set_text | ( | const String & | text | ) |

  | Causes the given text to appear superimposed on the progress bar. Parameters:
  text | A text string.

The documentation for this class was generated from the following file:

- progressbar.h

Main Page - Footer